%global numcomm 119
%global alphatag 17a4



Name: pcs
Version: 0.11.7
Release: 99+git%{?numcomm:.%{numcomm}}%{?alphatag:.%{alphatag}}%{?dirty:.%{dirty}}%{?cibranch:.%{cibranch}}%{?dist}
# https://docs.fedoraproject.org/en-US/packaging-guidelines/LicensingGuidelines/
# https://fedoraproject.org/wiki/Licensing:Main?rd=Licensing#Good_Licenses
# GPL-2.0-only: pcs
# Apache-2.0: dataclasses, tornado
# Apache-2.0 or BSD-3-Clause: dateutil
# MIT: backports, childprocess, dacite, ethon, mustermann, nio4r, rack,
#      rack-protection, rack-test, sinatra, tilt
# BSD-2-Clause or Ruby: ruby2_keywords
# BSD 3-Clause: puma
# BSD-3-Clause and MIT: ffi
# Some gems we bundle are just dependencies of gems that we use,
# here is their dependency tree (we directly require the 1st level only):
# ethon:
#   ffi
# puma:
#   nio4r
# sinatra:
#   mustermann:
#     ruby2_keywords
#   tilt
License: GPL-2.0-only AND Apache-2.0 AND MIT AND BSD-2-Clause AND BSD-3-Clause AND (Apache-2.0 OR BSD-3-CLause) AND (BSD-2-Clause OR Ruby)
URL: https://github.com/ClusterLabs/pcs
Summary: Pacemaker/Corosync Configuration System

%global pcs_snmp_pkg_name  pcs-snmp

%global pyagentx_version   0.4.pcs.2

%global pcs_bundled_dir pcs_bundled

%global required_pacemaker_version 2.1.0


# mangling shebang in /usr/lib/pcsd/vendor/bundle/ruby/gems/rack-2.0.5/test/cgi/test from /usr/bin/env ruby to #!/usr/bin/ruby
#*** ERROR: ./usr/lib/pcsd/vendor/bundle/ruby/gems/rack-2.0.5/test/cgi/test.ru has shebang which doesn't start with '/' (../../bin/rackup)
#mangling shebang in /usr/lib/pcsd/vendor/bundle/ruby/gems/rack-2.0.5/test/cgi/rackup_stub.rb from /usr/bin/env ruby to #!/usr/bin/ruby
#*** WARNING: ./usr/lib/pcsd/vendor/bundle/ruby/gems/rack-2.0.5/test/cgi/sample_rackup.ru is executable but has empty or no shebang, removing executable bit
#*** WARNING: ./usr/lib/pcsd/vendor/bundle/ruby/gems/rack-2.0.5/test/cgi/lighttpd.conf is executable but has empty or no shebang, removing executable bit
#*** ERROR: ambiguous python shebang in /usr/lib/pcsd/vendor/bundle/ruby/gems/ffi-1.9.25/ext/ffi_c/libffi/generate-darwin-source-and-headers.py: #!/usr/bin/env python. Change it to python3 (or python2) explicitly.
%undefine __brp_mangle_shebangs

# https://fedoraproject.org/wiki/Changes/Avoid_usr_bin_python_in_RPM_Build#Python_bytecompilation
# Enforce python3 because bytecompilation of tornado produced warnings:
# DEPRECATION WARNING: python2 invoked with /usr/bin/python.
#    Use /usr/bin/python3 or /usr/bin/python2
#    /usr/bin/python will be removed or switched to Python 3 in the future.
#global __python {__python3}

Source0: %{name}-%{version}%{?numcomm:+%{numcomm}}%{?alphatag:-%{alphatag}}%{?dirty:-%{dirty}}.tar.gz

Source41: pyagentx-%{pyagentx_version}.tar.gz
Source42: dacite-1.8.0.tar.gz
Source43: python-dateutil-2.9.0.post0.tar.gz
Source44: tornado-6.4.tar.gz

Source80: backports-3.25.0.gem
Source81: base64-0.2.0.gem
Source82: childprocess-5.0.0.gem
Source83: ethon-0.16.0.gem
Source84: ffi-1.16.3.gem
Source85: mustermann-3.0.0.gem
Source86: nio4r-2.7.1.gem
Source87: power_assert-2.0.3.gem
Source88: puma-6.4.2.gem
Source89: rack-3.0.10.gem
Source90: rack-protection-4.0.0.gem
Source91: rack-session-2.0.0.gem
Source92: rack-test-2.1.0.gem
Source93: rackup-2.1.0.gem
Source94: rexml-3.2.6.gem
Source95: ruby2_keywords-0.0.5.gem
Source96: sinatra-4.0.0.gem
Source97: test-unit-3.6.2.gem
Source98: tilt-2.3.0.gem
Source99: webrick-1.8.1.gem

# python for pcs
%if 0%{?fedora} >= 30
BuildRequires: python3 >= 3.9
BuildRequires: python3-setuptools
%endif

%if 0%{?rhel} >= 8 && 0%{?rhel} <= 9
BuildRequires: platform-python
BuildRequires: platform-python-setuptools
# for bundled python dateutil
BuildRequires: python3-setuptools_scm
%endif

BuildRequires: python3-devel
# for tier0 tests
BuildRequires: python3-cryptography
BuildRequires: python3-pyparsing
# required to pass ./configure
BuildRequires: python3-wheel
BuildRequires: python3-lxml
BuildRequires: python3-pycurl

# gcc for compiling custom rubygems
BuildRequires: gcc
BuildRequires: gcc-c++
BuildRequires: libffi-devel
# ruby and gems for pcsd
BuildRequires: ruby >= 2.5
BuildRequires: ruby-devel
BuildRequires: rubygems
# cluster stack packages for pkg-config
BuildRequires: booth
# not distributed in rhel 9
%if 0%{?rhel} < 9
BuildRequires: corosync-qdevice-devel
%endif
BuildRequires: corosynclib-devel >= 3.0
BuildRequires: fence-agents-common
%if 0%{?suse_version}
%if 0%{?suse_version} > 1500
BuildRequires: libpacemaker3-devel >= %{required_pacemaker_version}
%else
BuildRequires: libpacemaker-devel >= %{required_pacemaker_version}
%endif
%else
BuildRequires: pacemaker-libs-devel >= %{required_pacemaker_version}
%endif
BuildRequires: resource-agents
BuildRequires: sbd
# for post, preun and postun macros
BuildRequires: systemd
# for working with qdevice certificates (certutil) - used in configure.ac
%if 0%{?suse_version}
BuildRequires: mozilla-nss-tools
%else
BuildRequires: nss-tools
%endif

Requires: python3-cryptography
Requires: python3-lxml
Requires: python3-pycurl
Requires: python3-pyparsing
# ruby and gems for pcsd
Requires: ruby >= 2.5
Requires: rubygems
# for killall
Requires: psmisc
# cluster stack and related packages
Requires: pacemaker >= %{required_pacemaker_version}
Requires: corosync >= 3.0
# pcs enables corosync encryption by default so we require libknet1-plugins-all
Requires: libknet1-plugins-all
# for post, preun and postun macros
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd
# pam is used for authentication inside daemon (python ctypes)
# more details: https://bugzilla.redhat.com/show_bug.cgi?id=1717113
Requires: pam
# needs logrotate for /etc/logrotate.d/pcsd
Requires: logrotate
# for working with qdevice certificates (certutil)
%if 0%{?suse_version}
Requires: mozilla-nss-tools
%else
Requires: nss-tools
%endif

Provides: bundled(dacite) = 1.8.0
Provides: bundled(python-dateutil) = 2.9.0.post0
Provides: bundled(tornado) = 6.4

Provides: bundled(backports) = 3.25.0
Provides: bundled(base64) = 0.2.0
Provides: bundled(childprocess) = 5.0.0
Provides: bundled(ethon) = 0.16.0
Provides: bundled(ffi) = 1.16.3
Provides: bundled(mustermann) = 3.0.0
Provides: bundled(nio4r) = 2.7.1
Provides: bundled(power_assert) = 2.0.3
Provides: bundled(puma) = 6.4.2
Provides: bundled(rack) = 3.0.10
Provides: bundled(rack-protection) = 4.0.0
Provides: bundled(rack-session) = 2.0.0
Provides: bundled(rack-test) = 2.1.0
Provides: bundled(rackup) = 2.1.0
Provides: bundled(rexml) = 3.2.6
Provides: bundled(ruby2_keywords) = 0.0.5
Provides: bundled(sinatra) = 4.0.0
Provides: bundled(test-unit) = 3.6.2
Provides: bundled(tilt) = 2.3.0
Provides: bundled(webrick) = 1.8.1

%description
pcs is a corosync and pacemaker configuration tool.  It permits users to
easily view, modify and create pacemaker based clusters.

# pcs-snmp package definition
%package -n %{pcs_snmp_pkg_name}
Group: System Environment/Base
Summary: Pacemaker cluster SNMP agent
# https://fedoraproject.org/wiki/Licensing:Main?rd=Licensing#Good_Licenses
# GPL-2.0-only: pcs
# BSD-2-Clause: pyagentx
License: GPL-2.0-only AND BSD-2-Clause
URL: https://github.com/ClusterLabs/pcs

Requires: pcs = %{version}-%{release}
Requires: pacemaker
Requires: net-snmp

Provides: bundled(pyagentx) = %{pyagentx_version}

%description -n %{pcs_snmp_pkg_name}
SNMP agent that provides information about pacemaker cluster to the master agent (snmpd)

%prep
%autosetup -n %{name}-%{version}%{?numcomm:+%{numcomm}}%{?alphatag:-%{alphatag}}%{?dirty:-%{dirty}}

# prepare dirs/files necessary for building all bundles
# -----------------------------------------------------
# 2) rubygems sources
rubymod=`pkg-config --list-all | awk '{print $1}' | grep ^ruby | sort -n | tail -n 1`
rubyver=`pkg-config --variable=ruby_version $rubymod`
/usr/bin/mkdir -p pcsd/vendor/bundle//cache
cp -f %SOURCE80 pcsd/vendor/bundle//cache
cp -f %SOURCE81 pcsd/vendor/bundle//cache
cp -f %SOURCE82 pcsd/vendor/bundle//cache
cp -f %SOURCE83 pcsd/vendor/bundle//cache
cp -f %SOURCE84 pcsd/vendor/bundle//cache
cp -f %SOURCE85 pcsd/vendor/bundle//cache
cp -f %SOURCE86 pcsd/vendor/bundle//cache
cp -f %SOURCE87 pcsd/vendor/bundle//cache
cp -f %SOURCE88 pcsd/vendor/bundle//cache
cp -f %SOURCE89 pcsd/vendor/bundle//cache
cp -f %SOURCE90 pcsd/vendor/bundle//cache
cp -f %SOURCE91 pcsd/vendor/bundle//cache
cp -f %SOURCE92 pcsd/vendor/bundle//cache
cp -f %SOURCE93 pcsd/vendor/bundle//cache
cp -f %SOURCE94 pcsd/vendor/bundle//cache
cp -f %SOURCE95 pcsd/vendor/bundle//cache
cp -f %SOURCE96 pcsd/vendor/bundle//cache
cp -f %SOURCE97 pcsd/vendor/bundle//cache
cp -f %SOURCE98 pcsd/vendor/bundle//cache
cp -f %SOURCE99 pcsd/vendor/bundle//cache

# 3) dir for python bundles
/usr/bin/mkdir -p pcs_bundled/src
cp -f %SOURCE41 rpm/
cp -f %SOURCE42 rpm/
cp -f %SOURCE43 rpm/
cp -f %SOURCE44 rpm/

%build
%define debug_package %{nil}
./autogen.sh
%{configure} --enable-local-build --enable-use-local-cache-only
make all

%install
make install DESTDIR=%{buildroot}

%if %{defined suse_version}
rm -rf %{buildroot}/usr/share/doc/pcs/
%endif

# With this file there is "File is not stripped" problem during rpmdiff
# See https://docs.engineering.redhat.com/display/HTD/rpmdiff-elf-stripping
for fname in `find %{buildroot} -type f -name "*.so"`; do
  strip ${fname}
done
for dname in `find %{buildroot} -type d -name "ext"`; do
  rm -rf ${dname}
done

# prepare dynamic file list

mkdir -p dynamic_files

# pcs/pcsd
cat /dev/null > dynamic_files/pcs

# gem license files
for i in license gnu copying; do
 for x in `find %{buildroot} -type f -iname "${i}*" | grep ruby | grep -v dynamic_files`; do
  srcfile=`echo $x | sed -e 's#.*\/##g'`
  srcpkg=`echo $x | sed -e 's#.*gems/##g' -e 's/\(.*\)-\(.*\)/\1/'`
  mv $x dynamic_files/${srcpkg}_${srcfile}
  echo "@license dynamic_files/${srcpkg}_${srcfile}" >> dynamic_files/pcs
 done
done

# python modules licenses
for i in license; do
 for x in `find %{pcs_bundled_dir} -type f -iname "${i}*" | grep -v pyagentx`; do
  srcfile=`echo $x | sed -e 's#.*\/##g'`
  srcpkg=`echo $x | sed -e 's#.*src/##g' -e 's/\(.*\)-\(.*\)/\1/'`
  mv $x dynamic_files/${srcpkg}_${srcfile}
  echo "@license dynamic_files/${srcpkg}_${srcfile}" >> dynamic_files/pcs
 done
done

# python modules docs
# tornado has some extra README in the demos section
for i in readme contributors; do
 for x in `find %{pcs_bundled_dir} -type f -iname "${i}*" | grep -v pyagentx |grep -v demos`; do
  srcfile=`echo $x | sed -e 's#.*\/##g'`
  srcpkg=`echo $x | sed -e 's#.*src/##g' -e 's/\(.*\)-\(.*\)/\1/'`
  mv $x dynamic_files/${srcpkg}_${srcfile}
  echo "@doc dynamic_files/${srcpkg}_${srcfile}" >> dynamic_files/pcs
 done
done

# escaping % in spec file is "interesting"
sed -i -e 's#^@#%#g' dynamic_files/pcs

# pcs-snmp
cat /dev/null > dynamic_files/pcs-snmp

# python modules licenses
for i in license; do
 for x in `find %{pcs_bundled_dir} -type f -iname "${i}*" | grep pyagentx`; do
  srcfile=`echo $x | sed -e 's#.*\/##g'`
  srcpkg=`echo $x | sed -e 's#.*src/##g' -e 's/\(.*\)-\(.*\)/\1/'`
  mv $x dynamic_files/${srcpkg}_${srcfile}
  echo "@license dynamic_files/${srcpkg}_${srcfile}" >> dynamic_files/pcs-snmp
 done
done

# python modules docs
for i in readme contributors; do
 for x in `find %{pcs_bundled_dir} -type f -iname "${i}*" | grep pyagentx`; do
  srcfile=`echo $x | sed -e 's#.*\/##g'`
  srcpkg=`echo $x | sed -e 's#.*src/##g' -e 's/\(.*\)-\(.*\)/\1/'`
  mv $x dynamic_files/${srcpkg}_${srcfile}
  echo "@doc dynamic_files/${srcpkg}_${srcfile}" >> dynamic_files/pcs-snmp
 done
done

# escaping % in spec file is "interesting"
sed -i -e 's#^@#%#g' dynamic_files/pcs-snmp

%posttrans
# Make sure the new version of the daemon is running.
# Also, make sure to start pcsd-ruby if it hasn't been started or even
# installed before. This is done by restarting pcsd.service.
%{_bindir}/systemctl daemon-reload
%{_bindir}/systemctl try-restart pcsd.service

%post
%systemd_post pcsd.service
%systemd_post pcsd-ruby.service

%post -n %{pcs_snmp_pkg_name}
%systemd_post pcs_snmp_agent.service

%preun
%systemd_preun pcsd.service
%systemd_preun pcsd-ruby.service

%preun -n %{pcs_snmp_pkg_name}
%systemd_preun pcs_snmp_agent.service

%postun
%systemd_postun_with_restart pcsd.service
%systemd_postun_with_restart pcsd-ruby.service

%postun -n %{pcs_snmp_pkg_name}
%systemd_postun_with_restart pcs_snmp_agent.service

%files -f dynamic_files/pcs
%doc CHANGELOG.md
%doc README.md
%license COPYING

# pcs
%{_sbindir}/pcs
%{python3_sitelib}/*
%{_libdir}/pcs/*
%exclude %{_libdir}/pcs/pcs_snmp_agent
%exclude %{_libdir}/pcs/%{pcs_bundled_dir}/packages/pyagentx*

# bash completion
%{_datadir}/bash-completion/completions/pcs

# man page
%{_mandir}/man8/pcs.*

# pcsd
%{_sbindir}/pcsd
%{_libdir}/pcsd/*

# config files
%config(noreplace) %{_sysconfdir}/logrotate.d/pcsd
%config(noreplace) %{_sysconfdir}/sysconfig/pcsd
%config(noreplace) %{_sysconfdir}/pam.d/pcsd

# systemd unit
%{_unitdir}/pcsd.service
%{_unitdir}/pcsd-ruby.service

# log dir
%dir %{_var}/log/pcsd

# var/lib/pcsd
%{_sharedstatedir}/pcsd
%ghost %config(noreplace) %attr(0600,root,root) %{_sharedstatedir}/pcsd/cfgsync_ctl
%ghost %config(noreplace) %attr(0600,root,root) %{_sharedstatedir}/pcsd/known-hosts
%ghost %config(noreplace) %attr(0600,root,root) %{_sharedstatedir}/pcsd/pcsd.cookiesecret
%ghost %config(noreplace) %attr(0600,root,root) %{_sharedstatedir}/pcsd/pcsd.crt
%ghost %config(noreplace) %attr(0600,root,root) %{_sharedstatedir}/pcsd/pcsd.key
%ghost %config(noreplace) %attr(0644,root,root) %{_sharedstatedir}/pcsd/pcs_settings.conf
%ghost %config(noreplace) %attr(0644,root,root) %{_sharedstatedir}/pcsd/pcs_users.conf

# man page
%{_mandir}/man8/pcsd.*

%files -n %{pcs_snmp_pkg_name} -f dynamic_files/pcs-snmp
%{_libdir}/pcs/pcs_snmp_agent
%{_libdir}/pcs/%{pcs_bundled_dir}/packages/pyagentx*
%{_unitdir}/pcs_snmp_agent.service
%{_datadir}/snmp/mibs/PCMK-PCS*-MIB.txt
%{_mandir}/man8/pcs_snmp_agent.*
%config(noreplace) %{_sysconfdir}/sysconfig/pcs_snmp_agent
%doc CHANGELOG.md
%license COPYING

%changelog
* Thu May 02 2024 Autotools generated version <nobody@nowhere.org> - 0.11.7-1+119.17a4.
- Autotools generated version
- These aren't the droids you're looking for.
